/**
 * @file
 * jQuery code.
 * Based on code: Adrian "yEnS" Mato Gondelle, twitter: @adrianmg
 * Modifications for Drupal: Grzegorz Bartman grzegorz.bartman@openbit.pl
 */


// Setting up popup.
// 0 means disabled; 1 means enabled.
var popupStatus = 0;

/**
 * Loading popup with jQuery.
 */
function loadPopup() {
  // Loads popup only if it is disabled.
  if (popupStatus == 0) {
    $("#backgroundPopup").css( {
      "opacity": "0.7"
    });
    $("#backgroundPopup").fadeIn("slow");
    $("#popupContact").fadeIn("slow");
    popupStatus = 1;
  }
}

/**
 * Disabling popup with jQuery.
 */
function disablePopup() {
  // Disables popup only if it is enabled.
  if (popupStatus == 1) {
    $("#backgroundPopup").fadeOut("slow");
    $("#popupContact").fadeOut("slow");
    popupStatus = 0;
  }
}

/**
 * Centering popup.
 */
function centerPopup() {
  // Request data for centering.
  var windowWidth = document.documentElement.clientWidth;
  var windowHeight = document.documentElement.clientHeight;
  var popupHeight = $("#popupContact").height();
  var popupWidth = $("#popupContact").width();
  // Centering.
  $("#popupContact").css( {
    "position": "absolute",
    "top": windowHeight / 2 - popupHeight / 2,
    "left": windowWidth / 2 - popupWidth / 2
  });
  // Only need force for IE6.
  $("#backgroundPopup").css( {
    "height": windowHeight
  });

}

Drupal.behaviors.anonymousMessage = function (context) {
  var check_cookie = Drupal.settings.popup_message.check_cookie;
  if (typeof(check_cookie) == 'object') {
      check_cookie = check_cookie[(check_cookie.length - 1)];
    }
  var popup_message_cookie = $.cookie("popup_message_displayed");  
  if (popup_message_cookie != 1 || check_cookie == false) {
    // Set cookie.
    $.cookie("popup_message_displayed", 1, { path: '/' });

    // Add message.
    var popup_message_title = Drupal.settings.popup_message.title;    
    var popup_message_body = Drupal.settings.popup_message.body;    
    if (typeof(popup_message_title) == 'object') {
      popup_message_title = popup_message_title[(popup_message_title.length - 1)];
    }
    if (typeof(popup_message_body) == 'object') {
      popup_message_body = popup_message_body[(popup_message_body.length - 1)];
    }
    $('body').append('<div id="popupContact"><a id="popupContactClose">X</a>\n\
    <h1>' + popup_message_title + '</h1><p id="contactArea">' + popup_message_body
      + '</div><div id="backgroundPopup"></div>');

    // Loading popup.
    centerPopup();
    loadPopup();

    // Closing popup.
    // Click the x event!
    $("#popupContactClose").click(function() {
      disablePopup();
    });
    // Click out event!
    $("#backgroundPopup").click(function() {
      disablePopup();
    });
    // Press Escape event!
    $(document).keypress(function(e) {
      if (e.keyCode == 27 && popupStatus == 1) {
        disablePopup();
      }
    });
  }
};
